<html xmlns:v-on="http://www.w3.org/1999/xhtml">
<head>
    <title>Contact Us</title>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/vue/1.0.26/vue.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.19.2/axios.min.js"></script>

    <style>
        #contactForm {
            box-sizing: content-box;
            width: 178px;
            height: 545px;
        }

        p {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 12px;
        }

        #text-small {
            font-size: 9px;
        }

        #button {
            background: #075FDC;
            color: #FFFFFF;
            border: 1px solid #075FDC;
            -webkit-border-radius: 3px;
            -moz-border-radius: 3px;
            border-radius: 3px;
            width: 110px;
            height: 25px;
            -webkit-font-smoothing: antialiased;
        }
    </style>
</head>
<body>

<div id="contactForm">
    <form id="app" @submit="checkForm" action="contactRequest/contactUs" method="post">

        <div style="text-align: center; font-weight: bold;font-size: 18px">Contact us</div>

        <p v-if="errors.length">
            <b>Please correct the following error(s):</b>
        <ul>
            <li v-for="error in errors">{{ error }}</li>
        </ul>

        <p>
            <label for="requestType">Kind of request</label>
            <br>
            <select style="width: 178px; height: 25px"
                    id="requestType" name="requestType">
                <option v-for="requestType in requestTypes" name="requestType" value="{{requestType.id}}"
                        v-model="requestType">
                    {{ requestType.name }}
                </option>
            </select>

        <p>
            <label for="policyNumber">Policy Number</label>
            <br>
            <input type="text"
                   placeholder="{{ placeholder }}"
                   maxlength="10"
                   name="policyNumber"
                   id="policyNumber"
                   v-model="policyNumber"
                   size="25">

        <p>
            <label for="name">Name</label>
            <br>
            <input type="text"
                   placeholder="{{ placeholder }}"
                   maxlength="20"
                   name="name"
                   id="name"
                   v-model="name"
                   size="25">

        <p>
            <label for="surname">Surname</label>
            <br>
            <input type="text"
                   placeholder="{{ placeholder }}"
                   maxlength="20"
                   name="surname"
                   id="surname"
                   v-model="surname"
                   size="25">

        <p>
            <label for="message">Your request</label>
            <br>
            <textarea rows="5" cols="19"
                      maxlength="2500"
                      placeholder="{{ placeholder }}"
                      v-model="message"
                      name="message"
                      id="message"
                      v-on:keyup="countdown"></textarea>
        <p id='text-small' align="right">{{ remainingCount }}/2500

        <p align="right">
            <input id="button"
                   type="submit"
                   value="SEND REQUEST">
    </form>
</div>

<script>
    new Vue({
        el: '#app',
        data: {
            errors: [],
            requestTypes: [],
            policyNumber: null,
            name: null,
            surname: null,
            maxCount: 2500,
            remainingCount: 2500,
        },
        created() {
            axios.get("requestType/name")
                .then(response => {
                    this.requestTypes = response.data
                })
                .catch(error => {
                    console.log(error);
                });
        },
        methods: {
            checkForm: function (e) {
                this.errors = [];

                if (!this.policyNumber) {
                    this.errors.push("Policy number required.");
                } else if (!this.validPolicyNumber(this.policyNumber)) {
                    this.errors.push('Valid policy number required.');
                }
                if (!this.name) {
                    this.errors.push('Name required.');
                } else if (!this.validName(this.name)) {
                    this.errors.push('Valid name required.');
                }
                if (!this.surname) {
                    this.errors.push('Surname required.');
                } else if (!this.validSurname(this.surname)) {
                    this.errors.push('Valid surname required.');
                }

                if (!this.errors.length) {
                    return true;
                }

                e.preventDefault();
            },
            validPolicyNumber: function (policyNumber) {
                const re = /^[0-9a-zA-Z]+$/;
                return re.test(policyNumber);
            },
            validName: function (name) {
                const re = /^[A-Za-z]+$/;
                return re.test(name);
            },
            validSurname: function (surname) {
                const re = /^[A-Za-z]+$/;
                return re.test(surname);
            },
            countdown: function () {
                this.remainingCount = this.maxCount - this.message.length;
            }
        }
    })
</script>
</body>
</html>